Bug 879932 - Review Request: SocketW - It is a streaming socket C++ library designed to be easy to use
Summary: Review Request: SocketW - It is a streaming socket C++ library designed to be...
Status: CLOSED CURRENTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Nobody's working on this, feel free to take it
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Keywords:
Depends On:
Blocks: rigsofrods
TreeView+ depends on / blocked
 
Reported: 2012-11-25 15:37 UTC by Pavel Alexeev
Modified: 2014-02-09 00:15 UTC (History)
3 users (show)

(edit)
Clone Of:
(edit)
Last Closed: 2014-02-09 00:15:24 UTC
volker27: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Pavel Alexeev 2012-11-25 15:37:52 UTC
Spec URL: http://hubbitus.info/rpm/Fedora17/SocketW/SocketW.spec
SRPM URL: http://hubbitus.info/rpm/Fedora17/SocketW/SocketW-031026-1.fc17.src.rpm
Description:
It supports Unix sockets and TCP/IP sockets with optional SSL/TLS (OpenSSL)
support. It allows you to write portable and secure network applications quickly
without needing to spend time learning low-level system functions or reading
OpenSSL manuals.

Fedora Account System Username: hubbitus

Comment 1 Volker Fröhlich 2012-11-25 19:15:43 UTC
Add the isa macro in the devel sub-package -- http://fedoraproject.org/wiki/Packaging:Guidelines#Requiring_Base_Package

The build doesn't respect Fedora's compiler flags. As a consequence: SocketW-debuginfo.x86_64: E: debuginfo-without-sources

file-not-utf8 /usr/share/doc/SocketW-031026/README
SocketW.x86_64: W: shared-lib-calls-exit /usr/lib64/libSocketW.so.0.031026 exit@GLIBC_2.2.5 -- Please inform upstream!

Remove %defattr(-,root,root)

Consider to add the Todo file, the examples and the docs directory.

I'd personally drop the "It is a" from the summary.

Patch1 should have an upstream ticket, I think.

Comment 3 Michael Schwendt 2012-12-09 14:03:25 UTC
Just some comments, no need to provide a fresh src.rpm immediately:

> Name:           SocketW
> Group:          Development/Libraries

As long as we still fill in this Group Tag, library base packages enter group "System Environment/Libraries". The group you've specified is for -devel packages, for example.


> %package devel
> Summary:        It is a streaming socket C++ library designed to be easy to use

A very generic and reusable %summary for library -devel package is:

  Summary: Files for compiling software that uses %{name}

That's roughly what your -devel %description says. ;-)

Comment 5 Volker Fröhlich 2013-04-28 07:21:18 UTC
The latest SRPM is not available.

Comment 6 Pavel Alexeev 2013-04-28 07:41:02 UTC
Sorry. Reuploaded.

Comment 7 Volker Fröhlich 2013-04-28 10:30:08 UTC
That piece of software is from 2003. I can see you're packaging it because rigsofrods requires it, but I'm a bit skeptic. It might be worth convincing upstream to turn away from it.

Try to preserve the header timestamps by adding -p to install -c -m 644 *.h $(PREFIX_H) in src/Makefile

There's a compiler warning you might be able to solve. The exit call in the library and the outdated FSF postal address in the license file should also be addressed upstream. Given the age of this library, that's probably hopeless.

You could use the name macro for the patches.

Consider to wrap the long changelog lines

Scriptlets (post, postun) are commonly placed after the install section, but that's probably just convention.

APPROVED


Package Review
==============

Key:
[x] = Pass
[!] = Fail
[-] = Not applicable
[?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[-]: Package requires other packages for directories it uses.
[-]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.

PPC and ARM succeed

[x]: Package complies to the Packaging Guidelines
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Unknown or generated", "*No copyright* LGPL (v2.1 or later)". 2 files
     have unknown license. Detailed output of licensecheck in /home/makerpm
     /review-SocketW/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[-]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 133120 bytes in 19 files.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Fully versioned dependency in subpackages, if present.
[x]: Spec file lacks Packager, Vendor, PreReq tags.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.

Haven't tested it

[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[x]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[!]: Packages should try to preserve timestamps of original installed files.
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: SocketW-031026-3.fc20.x86_64.rpm
          SocketW-devel-031026-3.fc20.x86_64.rpm
SocketW.x86_64: W: shared-lib-calls-exit /usr/lib64/libSocketW.so.0.031026 exit@GLIBC_2.2.5
SocketW.x86_64: E: incorrect-fsf-address /usr/share/doc/SocketW-031026/LICENSE
SocketW-devel.x86_64: W: no-documentation
2 packages and 0 specfiles checked; 1 errors, 2 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint SocketW SocketW-devel
SocketW.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libSocketW.so.0.031026 /lib64/libm.so.6
SocketW.x86_64: W: shared-lib-calls-exit /usr/lib64/libSocketW.so.0.031026 exit@GLIBC_2.2.5
SocketW.x86_64: E: incorrect-fsf-address /usr/share/doc/SocketW-031026/LICENSE
SocketW-devel.x86_64: W: no-documentation
2 packages and 0 specfiles checked; 1 errors, 3 warnings.
# echo 'rpmlint-done:'



Requires
--------
SocketW (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libc.so.6()(64bit)
    libcrypto.so.10()(64bit)
    libcrypto.so.10(libcrypto.so.10)(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libm.so.6()(64bit)
    libssl.so.10()(64bit)
    libssl.so.10(libssl.so.10)(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    rtld(GNU_HASH)

SocketW-devel (rpmlib, GLIBC filtered):
    SocketW(x86-64)
    libSocketW.so.0()(64bit)



Provides
--------
SocketW:
    SocketW
    SocketW(x86-64)
    libSocketW.so.0()(64bit)

SocketW-devel:
    SocketW-devel
    SocketW-devel(x86-64)



MD5-sum check
-------------
http://www.digitalfanatics.org/cal/socketw/files/SocketW031026.tar.gz :
  CHECKSUM(SHA256) this package     : 44f2768fb62b2e1ad4d7a9a2c84a33c1f7770399630e563f8cfdd00667b43133
  CHECKSUM(SHA256) upstream package : 44f2768fb62b2e1ad4d7a9a2c84a33c1f7770399630e563f8cfdd00667b43133


Generated by fedora-review 0.4.0 (660ce56) last change: 2013-01-29
Buildroot used: fedora-rawhide-x86_64
Command line :/usr/bin/fedora-review -n SocketW

Comment 8 Pavel Alexeev 2013-04-29 17:40:50 UTC
(In reply to comment #7)
> That piece of software is from 2003. I can see you're packaging it because
> rigsofrods requires it, but I'm a bit skeptic. It might be worth convincing
> upstream to turn away from it.
I think it is simple and works. So, why not use it?

> Try to preserve the header timestamps by adding -p to install -c -m 644 *.h
> $(PREFIX_H) in src/Makefile
How you think it have worth by patching Makefile?
Then line below "install -c libSocketW.so.$(API_VER).$(SW_VER) $(PREFIX)/lib" also should have -p flag?

> There's a compiler warning you might be able to solve. The exit call in the
> library and the outdated FSF postal address in the license file should also
> be addressed upstream. Given the age of this library, that's probably
> hopeless.
You are absolutely right! Meantime I had contact upstream and they answer me. Quoting:
"Hi Pavel,
That code is very old and isn't maintained any longer. However, you have my permission to update the license file if you wish.

As I remember it the exit() calls should be easy to eliminate; isn't there a define in the code for throwing exceptions instead? Ah well, too long a time ago to remember :-)

Regards,
Anders Lindström"

I think it is not so serious issues to focus on its.

> You could use the name macro for the patches.
Sorry, could you please explain what you mean and for what?

> Consider to wrap the long changelog lines
Ok. Except URL to do not break it.

> Scriptlets (post, postun) are commonly placed after the install section, but
> that's probably just convention.

Ok, moved.

> APPROVED
Volker thank you very much for the review!

Comment 9 Pavel Alexeev 2013-04-29 18:50:30 UTC
New Package SCM Request
=======================
Package Name: SocketW
Short Description: It is a streaming socket C++ library designed to be easy to use
Owners: hubbitus
Branches: F-18 F-19 EL-6
InitialCC:

Comment 10 Gwyn Ciesla 2013-04-29 18:55:21 UTC
Git done (by process-git-requests).

Comment 11 Fedora Update System 2013-04-29 19:47:42 UTC
SocketW-031026-3.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/SocketW-031026-3.el6

Comment 12 Fedora Update System 2013-04-29 19:48:22 UTC
SocketW-031026-3.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/SocketW-031026-3.fc18

Comment 13 Fedora Update System 2013-04-29 19:48:41 UTC
SocketW-031026-3.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/SocketW-031026-3.fc19

Comment 14 Volker Fröhlich 2013-04-29 19:49:25 UTC
(In reply to comment #8)
> (In reply to comment #7)
> > That piece of software is from 2003. I can see you're packaging it because
> > rigsofrods requires it, but I'm a bit skeptic. It might be worth convincing
> > upstream to turn away from it.
> I think it is simple and works. So, why not use it?

I'm totally fine with that. But bare in mind, if problems arise, you're probably left alone in solving them.

> > Try to preserve the header timestamps by adding -p to install -c -m 644 *.h
> > $(PREFIX_H) in src/Makefile
> How you think it have worth by patching Makefile?
> Then line below "install -c libSocketW.so.$(API_VER).$(SW_VER)
> $(PREFIX)/lib" also should have -p flag?

I think the exact timestamp is not relevant there, as these files are generated at build time.


> I think it is not so serious issues to focus on its.

It's only a "should".

> > You could use the name macro for the patches.
> Sorry, could you please explain what you mean and for what?

e. g. Patch1:  %{name}-1.2.0-do_something.patch

Comment 15 Pavel Alexeev 2013-04-29 20:02:18 UTC
(In reply to comment #14)
> (In reply to comment #8)
> > (In reply to comment #7)
> I'm totally fine with that. But bare in mind, if problems arise, you're
> probably left alone in solving them.
Yeh. I'll try.

> > > Try to preserve the header timestamps by adding -p to install -c -m 644 *.h
> > > $(PREFIX_H) in src/Makefile
> > How you think it have worth by patching Makefile?
> > Then line below "install -c libSocketW.so.$(API_VER).$(SW_VER)
> > $(PREFIX)/lib" also should have -p flag?
> I think the exact timestamp is not relevant there, as these files are
> generated at build time.
I understand you point.
I add simple SocketW031026-preserve-time-on-headers.patch in rawhide. As updates pushed If you are not argue it will be in stable branches later to do not revoke updates.

Again thank you for the review and help.

Comment 16 Fedora Update System 2013-05-06 04:27:25 UTC
SocketW-031026-3.fc19 has been pushed to the Fedora 19 stable repository.

Comment 17 Fedora Update System 2013-05-10 04:56:11 UTC
SocketW-031026-3.fc18 has been pushed to the Fedora 18 stable repository.

Comment 18 Fedora Update System 2013-05-21 01:44:01 UTC
SocketW-031026-3.el6 has been pushed to the Fedora EPEL 6 stable repository.

Comment 19 Volker Fröhlich 2014-02-09 00:15:24 UTC
I don't know why this ticket is still open, but I think we can safely close it.


Note You need to log in before you can comment on or make changes to this bug.